%global git_long %{version}

Name:      eclipse-testng
Version:   6.9.11.1
Release:   1%{?dist}
Summary:   TestNG plug-in for Eclipse
License:   ASL 2.0
URL:       http://testng.org

BuildArch: noarch

Source0:   https://github.com/cbeust/testng-eclipse/archive/%{git_long}.tar.gz

# Fix embedded lib names
Patch0:    eclipse-testng-manifest.patch

# Add gson to classpath because in Fedora, testng-remote does not bundle it
Patch1:    eclipse-testng-no-bundled-gson.patch

Requires: guava
Requires: google-gson
Requires: junit
Requires: hamcrest-core
Requires: testng >= 6.9.10
Requires: testng-remote
Requires: beust-jcommander
Requires: snakeyaml
Requires: base64coder
Requires: bsh
Requires: slf4j

BuildRequires: tycho
BuildRequires: eclipse-jdt
BuildRequires: eclipse-m2e-core
BuildRequires: guava
BuildRequires: google-gson
BuildRequires: junit
BuildRequires: hamcrest-core
BuildRequires: testng >= 6.9.10
BuildRequires: testng-remote
BuildRequires: beust-jcommander
BuildRequires: snakeyaml
BuildRequires: base64coder
BuildRequires: bsh
BuildRequires: slf4j

%description
The Eclipse TestNG plug-in integrates the TestNG testing framework into the
Eclipse IDE.

%prep
%setup -q -n testng-eclipse-%{git_long}
%patch0
%patch1

# remove bundled libs
find -name '*.class' -exec rm -f '{}' \;
find -name '*.jar' -exec rm -f '{}' \;

# remove plugin not in Fedora
%pom_remove_plugin "pl.project13.maven:git-commit-id-plugin"
%pom_remove_plugin "pl.project13.maven:git-commit-id-plugin" testng-eclipse-plugin

sed -i -e '/^Bsh\.library/ s/bsh-2.0b4.jar/bsh.jar/' \
  testng-eclipse-plugin/src/main/org/testng/eclipse/TestNGMessages.properties

# build against fedora packaged libs
build-jar-repository -s -p testng-eclipse-plugin/lib \
  guava testng testng-remote/testng-remote-dist-shaded snakeyaml base64coder junit hamcrest/core \
  beust-jcommander bsh google-gson/gson slf4j/api
mv testng-eclipse-plugin/lib/beust-jcommander.jar testng-eclipse-plugin/lib/jcommander.jar
mv testng-eclipse-plugin/lib/testng-remote_testng-remote-dist-shaded.jar testng-eclipse-plugin/lib/testng-remote.jar
sed -i -e '2iEclipse-BundleShape: dir' testng-eclipse-plugin/META-INF/MANIFEST.MF

# don't install poms
%mvn_package "::pom::" __noinstall

%build
%mvn_build -j

%install
%mvn_install

# need to recreate the symlinks to libraries that were setup in "prep"
# this will cause some benign dangling-symlink rpmlint warnings
pushd %{buildroot}%{_datadir}/eclipse/droplets/testng/eclipse/plugins/org.testng.eclipse_*
rm lib/*.jar
build-jar-repository -s -p lib \
  guava testng testng-remote/testng-remote-dist-shaded snakeyaml base64coder junit hamcrest/core \
  beust-jcommander bsh google-gson/gson slf4j/api
mv lib/beust-jcommander.jar lib/jcommander.jar
mv lib/testng-remote_testng-remote-dist-shaded.jar lib/testng-remote.jar
popd

%files -f .mfiles
%doc README.md

%changelog
* Mon Apr 25 2016 Mat Booth <mat.booth@redhat.com> - 6.9.11.1-1
- Update to latest upstream release

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 6.9.9-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Oct 29 2015 Mat Booth <mat.booth@redhat.com> - 6.9.9-1
- Update to 6.9.9

* Wed Sep 02 2015 Mat Booth <mat.booth@redhat.com> - 6.9.5-1.git4d432f9
- Update to latest upstream
- Build with xmvn/tycho

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 6.8.6-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon Mar 9 2015 Alexander Kurtakov <akurtako@redhat.com> 6.8.6-5
- Add BR: slf4j now that it's no longer transitive one.

* Wed Jul 30 2014 Mat Booth <mat.booth@redhat.com> - 6.8.6-4
- Restore testng as an embedded lib due to runtime issues

* Mon Jun 16 2014 Mat Booth <mat.booth@redhat.com> - 6.8.6-3
- Use orbit style deps instead of symlinked libs embedded in the plug-in

* Thu Jun 12 2014 Mat Booth <mat.booth@redhat.com> - 6.8.6-2
- Patch for compatibility with eclipse luna

* Thu Jun 12 2014 Mat Booth <mat.booth@redhat.com> - 6.8.6-1
- Update to latest upstream release.

* Fri Mar 14 2014 Mat Booth <fedora@matbooth.co.uk> - 6.8.5-2.20130625gite0f6037
- Add BR/R on google-guice.

* Tue Jun 25 2013 Mat Booth <fedora@matbooth.co.uk> - 6.8.5-1.20130625gite0f6037
- Initial package.
